unit IntEdit;

interface

uses
  SysUtils, Classes, Controls, StdCtrls;

type
  TIntEdit = class(TEdit)
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    procedure SetValue(const V: Integer);
    function GetValue: Integer;
  published
    property Value : Integer read GetValue write SetValue;
    { Published declarations }
  end;

procedure Register;

implementation


procedure TIntEdit.SetValue(const V: Integer);
begin
 Text := inttostr(V);
end;

function TIntEdit.GetValue: Integer;
var t : Integer;
begin
 val(Text,Result,t); if t<>0 then Result := 0;
end;

procedure Register;
begin
  RegisterComponents('Samples', [TIntEdit]);
end;

end.
