unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, TSmallRamugenClasses;

type
  TForm1 = class(TForm)
    MidiArray1: TMidiArray;
    Button1: TButton;
    Memo1: TMemo;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure MidiArray1NoteStart(Sender: TObject; Pitch,
      CounterValue: Integer; var CarryOnPlaying: Boolean);
    procedure Button8Click(Sender: TObject);
  private
    procedure DoMemo;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.DoMemo;
var t : integer;
begin
  memo1.lines.Clear;
  for t := 0 to 50 do
  begin
    memo1.lines.add(inttostr(midiarray1.Pitch(t)));
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var t: integer;
begin
  randomize;
  MidiArray1.OpenMIDIDevice;
  for t := 40 to 90 do midiarray1.AddNote(t, (t * 10) - 250 , t + 35);
  DoMemo;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  MidiArray1.Shuffle(1,true,true,true,true);
  DoMemo;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  MidiArray1.Reverse(true,false,false);
  DoMemo;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  MidiArray1.Invert(0,127);
  DoMemo;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  {if not midiarray1.PlayingPhrase then }MidiArray1.PlayPhrase;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  midiarray1.Transpose(1);
  DoMemo;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  MidiArray1.RotateLeft(1);    
  DoMemo;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  midiarray1.Halt;
end;

procedure TForm1.MidiArray1NoteStart(Sender: TObject; Pitch,
  CounterValue: Integer; var CarryOnPlaying: Boolean);
begin
 //if countervalue = 6 then carryonplaying := false;    //try uncommenting this line!
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  midiarray1.SaveToFile();
end;

end.
